<?php

class modelIbackuper extends cmsModel {

	public function getCtype($id) {

		$content_model = cmsCore::getModel('content');

		$ctype = $content_model->getContentType($id);

		if (!$ctype) { return false; }

		$datasets = $content_model->getContentDatasets($id);

		$cats = $content_model->getCategoriesTree($ctype['name'], false);

		$fields = $content_model->getContentFields($ctype['name']);

		$props = $content_model->getContentProps($ctype['name']);

		$props_bind = $this->getPropsBinds($ctype['name']);

		$moderators = $content_model->getContentTypeModerators($ctype['name']);

		$rules  = cmsPermissions::getRulesList('content');

		$perm_values = cmsPermissions::getPermissions($ctype['name']);

		return array(
			'ctype' => $ctype,
			'datasets' => $datasets,
			'cats' => $cats,
			'fields' => $fields,
			'props' => $props,
			'props_bind' => $props_bind,
			'moderators' => $moderators,
			'rules' => $rules,
			'perm_values' => $perm_values
		);
	}

	public function addCtypeFields($ctype_name, $fields) {

		$content_table_name = 'con_' . $ctype_name;
		$fields_table_name = 'con_' . $ctype_name . '_fields';

		$sql = "TRUNCATE TABLE {#}{$fields_table_name}";
		$this->db->query($sql);

		foreach ($fields as $name => $field){
			if (!in_array($name, array('title', 'photo', 'user', 'date_pub', 'content'))){
				$field_class = "field" . string_to_camel('_', $field['type']);
				$field_parser = new $field_class(null, null);

				$sql = "ALTER TABLE {#}{$content_table_name} ADD `{$field['name']}` {$field_parser->getSQL()}";
				$this->db->query($sql);

				if ($field['is_in_filter'] && $field_parser->allow_index){
					$sql = "ALTER TABLE `{#}{$content_table_name}` ADD INDEX ( `{$field['name']}` )";
					$this->db->query($sql);
				}
			}
			$this->db->insert($fields_table_name, $field);
		}

		return true;
	}

	public function getPropsBinds($ctype_name, $category_id=false){

		$this->selectOnly('p.*');
		$this->select('p.id', 'prop_id');
		$this->select('i.*');

		$this->join('con_' . $ctype_name . '_props', 'p', 'p.id = i.prop_id');

		if ($category_id){
			$this->filterEqual('cat_id', $category_id);
		}

		$this->orderBy('ordering');

		return $this->get('con_' . $ctype_name . '_props_bind', function($item){
			$item['options'] = cmsModel::yamlToArray($item['options']);
			return $item;
		});
	}
}